//-----------------------------------------------------------
// smpl13(tc_cap).c
// ^C}JE^ɂpXv
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// 6MHz̕\ŃpX̌vsB
// {ݒł͍ő10msx̃pXx܂Ōv\B
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#include <AT91SAM7X_BITDEFINE.h>
#else
#include <AT91SAM7S.h>
#include <AT91SAM7S_BITDEFINE.h>
#endif

#include <vic.h>
#include <piocfg.h>

// VAʐM֘A
#define __UDP__
#include "share/us.c"

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
static const TPin pins[] = {
  // PB23 -> TIOA0
  { 1 << 23, &PIOB, PIOB_PID, PIO_PERIPH_A, PIO_PULLUP},
  // PB25 z> TIOA1
  { 1 << 25, &PIOB, PIOB_PID, PIO_PERIPH_A, PIO_PULLUP},
  // PB27 -> TIOA2
  { 1 << 27, &PIOB, PIOB_PID, PIO_PERIPH_A, PIO_PULLUP},
};
#else
static const TPin pins[] = {
  // PA0  -> TIOA0
  { 1 <<  0, &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_PULLUP},
  // PA15 -> TIOA1
  { 1 << 15, &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_PULLUP},
  // PA26 -> TIOA2
  { 1 << 26, &PIOA, PIOA_PID, PIO_PERIPH_B, PIO_PULLUP},
};

#endif

//========================================================
// MISC...
//========================================================
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 1000; j++) ;
}

//========================================================
// Timer/Counter
//========================================================
void InitTC (void) {
  PMC.PCER = (1 << TC0_PID) | (1 << TC1_PID) | (1 << TC2_PID);

  // TC0
  TC.CHANNEL[0].CCR = _TC_CLKDIS;     // NbN
  TC.CHANNEL[0].IDR = (uint32_t)-1;   // 荞ݖ
  TC.CHANNEL[0].CMR =
    _TC_CLKS_MCK_8                    // NbN\ 48MHz/8=6MHz
    | _TC_LDRB_RISING                 // オGbWRBLv`
    | _TC_LDRA_FALLING                // GbWRALv`
    | _TC_ETRGEDG_RISING              // オGbWŃJE^NA
    | _TC_ABETRG;                     // TIOBOgK
  TC.CHANNEL[0].CCR = _TC_CLKEN;      // NbN

  // TC1
  TC.CHANNEL[1].CCR = _TC_CLKDIS;
  TC.CHANNEL[1].IDR = (uint32_t)-1;
  TC.CHANNEL[1].CMR =
    _TC_CLKS_MCK_8
    | _TC_LDRB_RISING
    | _TC_LDRA_FALLING
    | _TC_ETRGEDG_RISING
    | _TC_ABETRG;
  TC.CHANNEL[1].CCR = _TC_CLKEN;

  // TC2
  TC.CHANNEL[2].CCR = _TC_CLKDIS;
  TC.CHANNEL[2].IDR = (uint32_t)-1;
  TC.CHANNEL[2].CMR =
    _TC_CLKS_MCK_8
    | _TC_LDRB_RISING
    | _TC_LDRA_FALLING
    | _TC_ETRGEDG_RISING
    | _TC_ABETRG;
  TC.CHANNEL[2].CCR = _TC_CLKEN;
}

//========================================================
// main
//========================================================
void main (void) {
  enableIRQ ();

  _us_init (_BAUDRATE, txb, sizeof (txb), rxb, sizeof (rxb));

  PIO_Configure (pins, PIO_LISTSIZE (pins));
  InitTC();

  while(1) {
    _us_printf("\rCAPTURE = %5d %5d %5d      ", TC.CHANNEL[0].RA, TC.CHANNEL[1].RA, TC.CHANNEL[2].RA);
    wait (100);
  }
}
