//-----------------------------------------------------------
// smpl1(pio1).c
// LED̓_
//   Copyright (c) BestTechnology CO.,LTD. 2005-2011
//-----------------------------------------------------------
// ʂɈPIOɑ΂̋@\pŊ蓖ĂĂ
// ̂ŁAR[h͔ώGɂȂ肪łB
// GCC Developer Liteł͌ݒ肵₷D悵ATMEL
// ̃Tv𓥏PAPIȌpAPI̗pĂB
// {ITPin\̂Ŋe[q̏錾APIO_Configure
// CɏĂB
// *PA0,PA1,PA2,PA29LEDVNڑ
//-----------------------------------------------------------

#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#include <AT91SAM7X.h>
#else
#include <AT91SAM7S.h>
#endif
// PIOȈՏ֐
#include <piocfg.h>

#include <math.h>

//-------------------------------------------------------------
// PIO[qݒ
//-------------------------------------------------------------
// [qCӂ̏ԂɏyуytF̊蓖ĂsB
//
// yTPin\́z
//  typedef struct {
//    unsigned int mask;        // [q}XN
//    struct st_pio *pio;       // PIORg[
//    unsigned char id;         // PID
//    TPinTypes type;           // s^Cv
//    unsigned char attribute;  // 
//  } TPin;
//  Emask
//    ݒ肷PIO̒[qw肷B̏p[^𕡐
//    ̒[qɓKpꍇ͑Sė񋓂B
//  Epio
//    SAM7V[YPIOAPIOBƂPIORg[
//    ̂B[q@\ɂPIORg[w
//    B
//  Eid
//    PIORg[̃ytFIDw肷B
//  Etype
//    [q@\蓖ĂB
//     PIO_PERIPH_A:ytFAɃATC
//     PIO_PERIPH_B:ytFBɃATC
//     PIO_INPUT   :͒[q
//     PIO_OUTPUT_0:o͒[q(0)
//     PIO_OUTPUT_1:o͒[q(1)
//  Eattribute
//     w肷Bw\B
//     PIO_DEFAULT  :ftHg(wȂ)
//     PIO_PULLUP   :vAbvON
//     PIO_DEGLITCH :Ob`tB^ON
//     PIO_OPENDRAIN:I[vhC
//
// yPIO_Configure֐z
//  unsigned char PIO_Configure(const TPin *list, unsigned int size);
//     TPin\̂ō\ϐ{֐ɓnŊs
//     B
//     ͍\̂̃|C^ƃTCYƂȂB
//
// yPIO_Set֐z
//  extern void PIO_Set(const TPin *pin );
//     w[qPIO_OUTPUT_0/1̏o͍\łSODR1B
//
// yPIO_Clear֐z
//  extern void PIO_Clear(const TPin *pin);
//     w[qPIO_OUTPUT_0/1̏o͍\łCODR1B
//
// yPIO_Get֐z
//  extern uint8_t PIO_Get(const TPin *pin);
//     w[qPIO_OUTPUT_0/1̏o͍\łOSDR̒lA
//     łȂPDSR̒lpiñ}XNr10ԂB

//-------------------------------------------------------------
#if defined (__AT91SAM7X128__) | defined (__AT91SAM7X256__) | defined (__AT91SAM7X512__)
#define _LED1 ((uint32_t)1 << 19) // PB19 -> LED1
#define _LED2 ((uint32_t)1 << 20) // PB20 -> LED2
#define _LED3 ((uint32_t)1 << 21) // PB21 -> LED3
#define _LED4 ((uint32_t)1 << 22) // PB22 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#else
#define _LED1 ((uint32_t)1 << 0)  // PA0  -> LED1
#define _LED2 ((uint32_t)1 << 1)  // PA1  -> LED2
#define _LED3 ((uint32_t)1 << 2)  // PA2  -> LED3
#define _LED4 ((uint32_t)1 << 29) // PA29 -> LED4
#define _ALL_LED  (_LED1 | _LED2 | _LED3 | _LED4)
#endif
static const TPin pins[] = {
  // [q}XN, PIORg[,    PID,     s^Cv,     l
  { _LED1,                 &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  { _LED2,                 &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  { _LED3,                 &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
  { _LED4,                 &PIOA, PIOA_PID, PIO_OUTPUT_1, PIO_DEFAULT},
};

//========================================================
// MISC...
//========================================================
// ʃ[vɂȈՃEFCg֐
void wait (int n) {
  volatile int i, j;

  for (i = 0; i < n; i++)
    for (j = 0; j < 100; j++) ;
}

// w[qHIGH (PIO_SetgĂȂ)
static __inline__ void PIOA_SetOutput (uint32_t d) {
  PIOA.SODR = d;
}

// w[qLOW (PIO_CleargĂȂ)
static __inline__ void PIOA_ClearOutput (uint32_t d) {
  PIOA.CODR = d;
}

// 100̃[v1`100%̋^PWM쐬
void duty (int *on) {
  int i;
  for (i = 0; i < 100; i++) {
    if (on[0] <= i) PIOA_SetOutput (_LED1); else PIOA_ClearOutput (_LED1);
    if (on[1] <= i) PIOA_SetOutput (_LED2); else PIOA_ClearOutput (_LED2);
    if (on[2] <= i) PIOA_SetOutput (_LED3); else PIOA_ClearOutput (_LED3);
    if (on[3] <= i) PIOA_SetOutput (_LED4); else PIOA_ClearOutput (_LED4);
    wait (1);
  }
}

// 0..3bitLED1..4Ɋ蓖
void pattern (int on) {
  int off;

  on =
    ((on & 1) ? _LED1 : 0)
    | ((on & 2) ? _LED2 : 0)
    | ((on & 4) ? _LED3 : 0)
    | ((on & 8) ? _LED4 : 0);
  off = ~on & _ALL_LED;

  PIOA_SetOutput (off);   // 
  PIOA_ClearOutput (on);  // _
}

//========================================================
// main
//========================================================
void main (void) {
  int i, j, k[4];

  // PIO
  PIO_Configure (pins, PIO_LISTSIZE (pins));

  // 낢ȓ_p^[o
  for (;;) {

    for (j = 0; j < 4; j++) {
      pattern (0);
      wait (5000);
      pattern (15);
      wait (5000);
    }

    for (j = 0; j <= 15; j++) {
      pattern (j);
      wait (7000);
    }

    for (j = 14; j >= 0; j--) {
      pattern (j);
      wait (7000);
    }

    for (j = 0; j < 4; j++) {
      pattern (0b1010);
      wait (10000);
      pattern (0b0101);
      wait (10000);
    }

    for (j = 0; j < 4; j++) {
      pattern (0b1100);
      wait (10000);
      pattern (0b0011);
      wait (10000);
    }

    for (j = 0; j < 3; j++) {
      k[0] = k[1] = k[2] = k[3] = 0;
      for (i = 0; i < 100; i++) duty (k);
      k[0] = k[1] = k[2] = k[3] = 30;
      for (i = 0; i < 100; i++) duty (k);
      k[0] = k[1] = k[2] = k[3] = 50;
      for (i = 0; i < 100; i++) duty (k);
      k[0] = k[1] = k[2] = k[3] = 75;
      for (i = 0; i < 100; i++) duty (k);
      k[0] = k[1] = k[2] = k[3] = 100;
      for (i = 0; i < 100; i++) duty (k);
    }

#if !(defined (__AT91SAM7S32__) & defined (__SRAM_TARGET__)) // SRAM^[QbgƂƃTCYI[ô
    for (j = 0; j < 3000; j++) {
      k[0] = k[1] = k[2] = k[3] = 50 + cos(j / 60.0) * 50.0;
      duty(k);
    }

    for (j = 0; j < 3000; j++) {
      k[0] = 50 + cos(j / 60.0) * 50.0;
      k[1] = 50 + cos(j / 60.0 + 1.0 * M_PI / 4.0) * 50.0;
      k[2] = 50 + cos(j / 60.0 + 2.0 * M_PI / 4.0) * 50.0;
      k[3] = 50 + cos(j / 60.0 + 3.0 * M_PI / 4.0) * 50.0;
      duty(k);
    }
#endif
  }
}
